import express from 'express';
import { Logger } from 'winston';
import { Application, Module } from 'graphql-modules';
import DataLoader from 'dataloader';
import { Plugin } from 'graphql-yoga';
import { CompoundEntityRef } from '@backstage/catalog-model';
import { Config } from '@backstage/config';
import { CatalogClient } from '@backstage/catalog-client';

interface ResolverContext {
    application: Application;
    loader: DataLoader<any, any>;
    catalog: CatalogClient;
    refToId?: (ref: CompoundEntityRef | string) => string;
}

interface RouterOptions {
    config: Config;
    logger: Logger;
    modules?: Module[];
    plugins?: Plugin[];
    createLoader?: (context: Omit<ResolverContext, 'loader'>) => DataLoader<string, any>;
    refToId?: (ref: CompoundEntityRef | string) => string;
}
declare function createRouter({ config, logger, modules, plugins, createLoader, refToId, }: RouterOptions): Promise<express.Router>;

export { RouterOptions, createRouter };
